# stick
[![GoDoc](https://godoc.org/git.sr.ht/~tslocum/stick?status.svg)](https://godoc.org/git.sr.ht/~tslocum/stick)
[![builds.sr.ht status](https://builds.sr.ht/~tslocum/stick.svg)](https://builds.sr.ht/~tslocum/stick?)
[![Donate](https://img.shields.io/liberapay/receives/rocketnine.space.svg?logo=liberapay)](https://liberapay.com/rocketnine.space)

Shareable Git-backed Markdown-formatted notes

## Demo

[**Try stick**](https://stick.rocketnine.space/#login/c89f5381659ad34bd84967fdbbb5e76834495063dc93ed3902bf4e186f4def90)

**Note:** Read-only except checking/un-checking items.

## Install

Choose one of the following methods:

### Download

[**Download stick**](https://stick.rocketnine.space/download/) (Windows and Linux binaries are available)

### Compile

```
GO111MODULE=on go get -u git.sr.ht/~tslocum/stick
```

## Configure

Initialize a notebook by creating an empty git repository:

```
stick init /home/stick/notes/johnsnotes
```

Configure stick via ~/.config/stick/stick.yml (or elsewhere by using --config later)

```yaml
# Used when hashing data (set to a random string)
salt: xXxsh3cr3txXx

# Serve notes on localhost only
# Set to :9991 to serve on all interfaces (not recommended, use a reverse proxy instead)
serve: localhost:9991

# Authors are defined by email and name (used when committing)
authors:
  john@hotmail.com: John Doe
  jane@aol.com: Jane Doe

# Notebooks can be shared between authors with varying access levels
# When an access level isn't specified, read/write is assumed
# John's notebook allows read/write access to himself and read-only access to Jane
notebooks:
  John's notes:
    repo: /home/stick/notes/johnsnotes
    serve:
      - john@hotmail.com
      - jane@aol.com: read

  Jane's notes:
    repo: /home/stick/notes/janesnotes
    serve:
      - jane@aol.com
      - john@hotmail.com: read

  Shared notes:
    repo: /home/stick/notes/shared
    serve:
      - john@hotmail.com
      - jane@aol.com
```

## Run

```
stick serve
```

### Options

Note display and behavior can be customized via the **options directive**:

```
[//]: # (list,sort)

* [ ] Eggs
* [ ] Flour
* [X] Milk
```

This directive must be the first line of the note. When using the web interface
to change note options, this directive will be added and updated automatically.

The following options are available:

#### Pin

Pinned notes will appear in another notebook labeled "Pinned"

#### List

Emphasize and remove duplicate list items

#### Sort

Sort list items alphabetically

#### Dismissed

Show dismissed list items

## Support

Please share suggestions/issues [here](https://todo.sr.ht/~tslocum/stick).
